diff --git a/contrib/awk/README.DRAGONFLY b/contrib/awk/README.DRAGONFLY
index c37cfb8..bfa0cca 100644
--- a/contrib/awk/README.DRAGONFLY
+++ b/contrib/awk/README.DRAGONFLY
@@ -12,6 +12,3 @@ sha1 = 538fd69fb0fd01966eb41ad20c336215b4a07301
 Note that only the latest tarball is available on B.Kernighan's site.
 A list of files removed is in README.DELETED
 
-Local modifications applied to following files:
-	run.c
-	trans.c
diff --git a/contrib/binutils-2.21/README.DRAGONFLY b/contrib/binutils-2.21/README.DRAGONFLY
index 0e460ea..6194752 100644
--- a/contrib/binutils-2.21/README.DRAGONFLY
+++ b/contrib/binutils-2.21/README.DRAGONFLY
@@ -11,9 +11,3 @@ sha1 = f188490772cc902ec44a76545887bff60dbfa22d
 
 A list of files and directories removed is in README.DELETED
 
-Local modifications applied to following files:
-	binutils/arlex.1
-	bfd/bfdver.h (new)
-	gold/options.cc
-	gold/options.h
-	ld/ldlex.l
diff --git a/contrib/binutils-2.22/README.DRAGONFLY b/contrib/binutils-2.22/README.DRAGONFLY
index d077726e..041771c 100644
--- a/contrib/binutils-2.22/README.DRAGONFLY
+++ b/contrib/binutils-2.22/README.DRAGONFLY
@@ -10,9 +10,3 @@ sha1 = 65b304a0b9a53a686ce50a01173d1f40f8efe404
 
 A list of files and directories removed is in README.DELETED
 
-Local modifications applied to following files:
-	bfd/bfdver.h (new)
-	gold/i386.cc
-	gold/options.cc
-	gold/x86_64.cc
-	ld/ldlex.l
diff --git a/contrib/cvs-1.12/README.DRAGONFLY b/contrib/cvs-1.12/README.DRAGONFLY
index fe54d59..acab902 100644
--- a/contrib/cvs-1.12/README.DRAGONFLY
+++ b/contrib/cvs-1.12/README.DRAGONFLY
@@ -11,19 +11,3 @@ sha1 = 93a8dacc6ff0e723a130835713235863f1f5ada9
 
 A list of files and directories removed is in README.DELETED
 
-Local modifications applied to following files:
-	doc/cvs.1
-	doc/cvs.texinfo
-	lib/closeout.c
-	lib/save-cwd.c
-	lib/xgetcwd.c
-	src/annotate.c
-	src/commit.c
-	src/cvs.h
-	src/diff.c
-	src/main.c
-	src/parseinfo.c
-	src/rcs.c
-	src/rcs.h
-	src/root.c
-	src/zlib.c
diff --git a/contrib/diffutils/README.DRAGONFLY b/contrib/diffutils/README.DRAGONFLY
index c99f315..7e7872a 100644
--- a/contrib/diffutils/README.DRAGONFLY
+++ b/contrib/diffutils/README.DRAGONFLY
@@ -11,9 +11,3 @@ sha1 = 6463cce7d3eb73489996baefd0e4425928ecd61e
 
 A list of files and directories removed is in README.DELETED
 
-Local modifications applied to following files:
-	src/diff.c
-	src/diff3.c
-	src/sdiff.c
-	src/side.c
-	lib/wcwidth.c
diff --git a/contrib/flex/README.DRAGONFLY b/contrib/flex/README.DRAGONFLY
index e32f53b..02f4bb3 100644
--- a/contrib/flex/README.DRAGONFLY
+++ b/contrib/flex/README.DRAGONFLY
@@ -11,10 +11,3 @@ sha1 = db4b140f2aff34c6197cab919828cc4146aae218
 
 A list of files and directories removed is in README.DELETED
 
-Local modifications applied to following files:
-	doc/flex.1  (fix bad version number)
-	flexdef.h   (add lerrs_fatal prototype)
-	scanflags.c (fix sf_init call to lerrs_fatal)
-	main.c      (fix ambiguous if-else)
-	buf.c       (fix discard const char qualifier)
-	filter.c    (fix declaring unused variables)
\ No newline at end of file
diff --git a/contrib/gcc-4.4/README.DRAGONFLY b/contrib/gcc-4.4/README.DRAGONFLY
index ec707c7..969be10 100644
--- a/contrib/gcc-4.4/README.DRAGONFLY
+++ b/contrib/gcc-4.4/README.DRAGONFLY
@@ -16,26 +16,3 @@
     size = 63179340
     sha1 = a6c834b0c2f58583da1d093de7a81a20ede9af75
 
-
-    The following files have been added or patched:
-    =======================================================
-    /libstdc++-v3/config/os/bsd/dragonfly/ctype_base.h
-    /libstdc++-v3/config/os/bsd/dragonfly/ctype_inline.h
-    /libstdc++-v3/config/os/bsd/dragonfly/ctype_noninline.h
-    /libstdc++-v3/config/os/bsd/dragonfly/os_defines.h
-    /libstdc++-v3/config/locale/dragonfly/c_locale.cc
-    /libstdc++-v3/config/locale/dragonfly/ctype_members.cc
-    /libstdc++-v3/configure.host
-    /libgcc/config.host
-    /gcc/c-format.c
-    /gcc/c-opts.c
-    /gcc/cfgloop.c
-    /gcc/crtstuff.c
-    /gcc/tree-inline.c
-    /gcc/unwind-dw2-fde-glibc.c
-    /gcc/config/dragonfly.h
-    /gcc/config/i386/dragonfly-unwind.h
-    /gcc/config/i386/dragonfly.h
-    /gcc/config/i386/dragonfly64.h
-    /gcc/config/i386/i386.c
-    /include/libiberty.h
diff --git a/contrib/gcc-4.7/README.DRAGONFLY b/contrib/gcc-4.7/README.DRAGONFLY
index e90955b..0e70e4b 100644
--- a/contrib/gcc-4.7/README.DRAGONFLY
+++ b/contrib/gcc-4.7/README.DRAGONFLY
@@ -11,28 +11,3 @@ sha1 = 69e02737bd6e1a7c6047d801600d39c32b9427ca
 
 The file README.DELETED contains a list of deleted files and directories.
 
-
-The following files have been added:
-==============================================================
-gcc/config/dragonfly-stdint.h
-gcc/config/dragonfly.h
-gcc/config/i386/dragonfly.h
-libgcc/config/i386/dragonfly-unwind.h
-libgcc/enable-execute-stack-freebsd.c
-libstdc++-v3/config/locale/dragonfly/c_locale.cc
-libstdc++-v3/config/locale/dragonfly/ctype_members.cc
-libstdc++-v3/config/os/bsd/dragonfly/ctype_base.h
-libstdc++-v3/config/os/bsd/dragonfly/ctype_configure_char.cc
-libstdc++-v3/config/os/bsd/dragonfly/ctype_inline.h
-libstdc++-v3/config/os/bsd/dragonfly/os_defines.h
-
-The following files have been patched:
-==============================================================
-gcc/c-family/c-format.c
-gcc/config/i386/i386.c
-gcc/gcc.c
-gcc/ginclude/stddef.h
-gcc/tree-inline.c
-include/libiberty.h
-libgcc/crtstuff.c
-libgcc/unwind-dw2-fde-dip.c
diff --git a/contrib/gdb-7/README.DRAGONFLY b/contrib/gdb-7/README.DRAGONFLY
index 8a441b1..e812ad2 100644
--- a/contrib/gdb-7/README.DRAGONFLY
+++ b/contrib/gdb-7/README.DRAGONFLY
@@ -11,24 +11,3 @@ sha1 = 0e38633b3902070d9c6755e4c54602148a094361
 
 A list of files and directories removed is in README.DELETED
 
-The following files were added:
-	gdb/amd64dfly-nat.c
-	gdb/amd64dfly-tdep.c
-	gdb/i386dfly-nat.c
-	gdb/i386dfly-tdep.c
-
-Local modifications applied to following files:
-	gdb/amd64-tdep.h
-	gdb/common/ptid.h
-	gdb/configure.host
-	gdb/configure.tgt
-	gdb/defs.h
-	gdb/exec.c
-	gdb/i386-tdep.h
-	gdb/i386bsd-nat.c
-	gdb/i386fbsd-tdep.c
-	gdb/inferiors.c
-	gdb/main.c
-	gdb/osabi.c
-	include/elf/common.h
-	include/libiberty.h
diff --git a/contrib/gdtoa/README.DRAGONFLY b/contrib/gdtoa/README.DRAGONFLY
index 30e9835..c226b01 100644
--- a/contrib/gdtoa/README.DRAGONFLY
+++ b/contrib/gdtoa/README.DRAGONFLY
@@ -6,13 +6,5 @@ TBW
 
 A list of files and directories removed is in README.DELETED
 
-Local modifications applied to following files for locale support:
-	gdtoaimp.h
-	strtod.c
-	strtodg.c
-	strtof.c
-	strtod.c
-	strtorx.c
-
 This file should have been in the vendor branch and has since been modified:
 	strtorQ.c
diff --git a/contrib/grep/README.DRAGONFLY b/contrib/grep/README.DRAGONFLY
index 53d6337..42ece96 100644
--- a/contrib/grep/README.DRAGONFLY
+++ b/contrib/grep/README.DRAGONFLY
@@ -11,5 +11,3 @@ sha1 = fb6ea404a0ef915334ca6212c7b517432ffe193e
 
 A list of files and directories removed is in README.DELETED
 
-Local modifications applied to following files:
-	src/main.c
diff --git a/contrib/less/README.DRAGONFLY b/contrib/less/README.DRAGONFLY
index cdd80d2..67188c0 100644
--- a/contrib/less/README.DRAGONFLY
+++ b/contrib/less/README.DRAGONFLY
@@ -18,5 +18,3 @@ This source is used in:
 	usr.bin/lessecho
 	usr.bin/lesskey
 
-Local modifications applied to following files:
-	command.c
diff --git a/contrib/libedit/README.DRAGONFLY b/contrib/libedit/README.DRAGONFLY
index 38e9b05..908336c 100644
--- a/contrib/libedit/README.DRAGONFLY
+++ b/contrib/libedit/README.DRAGONFLY
@@ -11,9 +11,3 @@ sha1 = 2f20bc835c1282b6815c4c8e2f852d6fe4318f7a
 
 A list of files and directories removed is in README.DELETED
 
-Local modifications applied to following files:
-	src/chartype.h
-	src/el.c
-	src/filecomplete.c
-	src/sys.h
-	src/vi.c
diff --git a/contrib/mdocml/README.DRAGONFLY b/contrib/mdocml/README.DRAGONFLY
index 0f2d217..2f7042b 100644
--- a/contrib/mdocml/README.DRAGONFLY
+++ b/contrib/mdocml/README.DRAGONFLY
@@ -9,8 +9,3 @@ date = 5 October 2013
 size = 286400
 sha1 = 6a86cc4f373bcc51aa8bf1a7499db368e977a166
 
-Local modifications applied to the following files:
-	config.h
-	lib.in
-	msec.in
-	mandoc.3
diff --git a/contrib/ncurses/README.DRAGONFLY b/contrib/ncurses/README.DRAGONFLY
index 108f77b..c6ab687 100644
--- a/contrib/ncurses/README.DRAGONFLY
+++ b/contrib/ncurses/README.DRAGONFLY
@@ -21,10 +21,3 @@ The .h files copied into base where created using configure opts:
 	--with-default-terminfo-dir=/usr/share/terminfo
 	--with-terminfo-dirs=/usr/share/terminfo
 
-The following files have been modified:
-	ncurses/tinfo/comp_scan.c
-	misc/terminfo.src [1]
-
-[1] smcup and rmcup were removed from xterm-basic to disable the
-    restoration of the console after less, more, man, and other
-    utilities are executed.  It was rendering them useless.
diff --git a/contrib/tcsh-6/README.DRAGONFLY b/contrib/tcsh-6/README.DRAGONFLY
index 04cfb15b..5c2386d 100644
--- a/contrib/tcsh-6/README.DRAGONFLY
+++ b/contrib/tcsh-6/README.DRAGONFLY
@@ -11,16 +11,3 @@ sha1 = eee2035645737197ff8059c84933a75d23cd76f9
 
 A list of files removed is in README.DELETED
 
-Local modifications applied to following files:
-	ed.init.c
-	ed.term.c
-	ed.term.h
-	ed.screen.c
-	gethost.c
-	sh.c
-	sh.h
-	sh.decls.h
-	sh.func.c
-	sh.init.c
-	sh.set.c
-	sh.term.h
diff --git a/contrib/texinfo/README.DRAGONFLY b/contrib/texinfo/README.DRAGONFLY
index 7de7a03..e3bd97e 100644
--- a/contrib/texinfo/README.DRAGONFLY
+++ b/contrib/texinfo/README.DRAGONFLY
@@ -11,6 +11,3 @@ sha1 = a1533cf8e03ea4fa6c443b73f4c85e4da04dead0
 
 A list of files and directories removed is in README.DELETED
 
-Local modifications applied to following files:
-	install-info/install-info.c
-	util/texindex.c