diff --git a/devel/gsoap/Makefile b/devel/gsoap/Makefile
new file mode 100644
index 0000000..9f96021
--- /dev/null
+++ b/devel/gsoap/Makefile
@@ -0,0 +1,43 @@
+# Created by: Sergey Matveychuk <sem@ciam.ru>
+# $FreeBSD$
+
+PORTNAME=	gsoap
+PORTVERSION=	2.8.18
+CATEGORIES=	devel
+MASTER_SITES=	SF/${PORTNAME}2/gSOAP
+DISTNAME=	${PORTNAME}_${PORTVERSION}
+
+MAINTAINER=	5u623l20@gmail.com
+COMMENT=	Generator Tools for Coding SOAP/XML Web Services in C and C++
+
+LICENSE=	GPLv2
+
+CONFIGURE_ENV=	LEX=flex YACC=yacc
+GNU_CONFIGURE=	yes
+MAKE_JOBS_UNSAFE=	yes
+USES=		pathfix zip
+WRKSRC=		${WRKDIR}/${PORTNAME}-${PORTVERSION:R}
+
+OPTIONS_RADIO=	SSL
+OPTIONS_RADIO_SSL=	GNUTLS OPENSSL
+OPTIONS_DEFAULT=	OPENSSL
+GNUTLS_LIB_DEPENDS=	libgnutls.so:${PORTSDIR}/security/gnutls \
+	   		libgcrypt.so:${PORTSDIR}/security/libgcrypt \
+			libgpg-error.so:${PORTSDIR}/security/libgpg-error
+GNUTLS_CONFIGURE_ON=	--enable-gnutls
+GNUTLS_LDFLAGS=		-L${LOCALBASE}/lib
+OPENSSL_CONFIGURE_ENABLE=	ssl
+
+post-patch:
+	${REINPLACE_CMD} -e 's| sys/timeb.h | |' \
+	    -e 's|-DSOAPCPP_IMPORT_PATH=|-DSOAPCPP2_IMPORT_PATH=|' \
+	    -e 's|-DWSDL_IMPORT_PATH=|-DWSDL2H_IMPORT_PATH=|' \
+	    ${WRKSRC}/${CONFIGURE_SCRIPT}
+
+post-install:
+	@${MKDIR} ${STAGEDIR}${PREFIX}/lib/gsoap
+	@${INSTALL_DATA} ${WRKSRC}/gsoap/stdsoap2.c \
+	    ${STAGEDIR}${PREFIX}/lib/gsoap
+	@${LN} -fs stdsoap2.c ${STAGEDIR}${PREFIX}/lib/gsoap/stdsoap2.cpp
+
+.include <bsd.port.mk>
diff --git a/devel/gsoap/distinfo b/devel/gsoap/distinfo
new file mode 100644
index 0000000..9ca5d7e
--- /dev/null
+++ b/devel/gsoap/distinfo
@@ -0,0 +1,2 @@
+SHA256 (gsoap_2.8.18.zip) = 764281a67020b7b7b982ddf8e7fdffae27f7a3e61af9ab4ec8a4705a67ba7ced
+SIZE (gsoap_2.8.18.zip) = 20596233
diff --git a/devel/gsoap/dragonfly/patch-configure b/devel/gsoap/dragonfly/patch-configure
new file mode 100644
index 0000000..e4336f4
--- /dev/null
+++ b/devel/gsoap/dragonfly/patch-configure
@@ -0,0 +1,10 @@
+--- configure.orig	2014-11-22 10:46:52.445555000 +0100
++++ configure		2014-11-22 10:46:28.149993000 +0100
+@@ -5026,6 +5026,7 @@
+ 			SAMPLE_EXTRA_LIBS="-lws2_32 -lkernel32 -luser32 -lgdi32 -lm"
+ 			WSDL2H_EXTRA_LIBS="-lws2_32 -lkernel32 -luser32 -lgdi32 -lm"
+ 			;;
++	*-*-dragonfly*) platform=FREEBSD ;;
+         *-*-freebsd*)   platform=FREEBSD ;;
+         *-*-openbsd*)   platform=OPENBSD ;;
+         *-*-irix*)      platform=IRIX ;;
diff --git a/devel/gsoap/files/patch-gsoap_wsdl_Makefile.in b/devel/gsoap/files/patch-gsoap_wsdl_Makefile.in
new file mode 100644
index 0000000..2e3e20c
--- /dev/null
+++ b/devel/gsoap/files/patch-gsoap_wsdl_Makefile.in
@@ -0,0 +1,11 @@
+--- gsoap/wsdl/Makefile.in.orig	2014-10-09 00:09:14.631256099 +0600
++++ gsoap/wsdl/Makefile.in	2014-10-09 00:09:33.119255143 +0600
+@@ -303,7 +303,7 @@
+ BUILT_SOURCES = $(SOAP_CPP_SRC)
+ wsdl2h_CFLAGS = $(C_DEBUG_FLAGS) $(WSDL2H_EXTRA_FLAGS)
+ wsdl2h_CXXFLAGS = $(C_DEBUG_FLAGS) $(WSDL2H_EXTRA_FLAGS) $(WSDL2H_IMPORTPATH)
+-wsdl2h_CPPFLAGS = $(AM_CPPFLAGS) $(SOAPCPP2_NONAMESPACES) -D$(platform)
++wsdl2h_CPPFLAGS = $(AM_CPPFLAGS) $(SOAPCPP2_NONAMESPACES) $(WSDL2H_IMPORTPATH) -D$(platform)
+ wsdl2h_SOURCES = wsdl2h.cpp wsdl.cpp schema.cpp types.cpp service.cpp soap.cpp mime.cpp wsp.cpp bpel.cpp $(SOAP_CPP_SRC)
+ wsdl2h_LDADD = $(SOAP_CPP_LIB) $(WSDL2H_EXTRA_LIBS)
+ CLEANFILES = *~ *C.cpp *H.h *Stub.h *.nsmap
diff --git a/devel/gsoap/pkg-descr b/devel/gsoap/pkg-descr
new file mode 100644
index 0000000..8840525
--- /dev/null
+++ b/devel/gsoap/pkg-descr
@@ -0,0 +1,11 @@
+The gSOAP Web services development toolkit offers an XML to C/C++ language
+binding to ease the development of SOAP/XML Web services in C and C/C++.
+Most toolkits for C++ Web services adopt a SOAP-centric view and offer APIs
+that require the use of class libraries for SOAP-specific data structures.
+This often forces a user to adapt the application logic to these libraries.
+In contrast, gSOAP provides a transparent SOAP API through the use of proven
+compiler technologies. These technologies leverage strong typing to map
+XML schemas to C/C++ definitions. Strong typing provides a greater assurance
+on content validation of both WSDL schemas and SOAP/XML messages.
+
+WWW: http://www.cs.fsu.edu/~engelen/soap.html
diff --git a/devel/gsoap/pkg-plist b/devel/gsoap/pkg-plist
new file mode 100644
index 0000000..99a6ddd
--- /dev/null
+++ b/devel/gsoap/pkg-plist
@@ -0,0 +1,183 @@
+bin/soapcpp2
+bin/wsdl2h
+include/stdsoap2.h
+lib/libgsoap++.a
+lib/libgsoap.a
+lib/libgsoapck++.a
+lib/libgsoapck.a
+lib/libgsoapssl++.a
+lib/libgsoapssl.a
+lib/gsoap/stdsoap2.c
+lib/gsoap/stdsoap2.cpp
+libdata/pkgconfig/gsoap++.pc
+libdata/pkgconfig/gsoap.pc
+libdata/pkgconfig/gsoapck++.pc
+libdata/pkgconfig/gsoapck.pc
+libdata/pkgconfig/gsoapssl++.pc
+libdata/pkgconfig/gsoapssl.pc
+%%DATADIR%%/WS/LEGAL.txt
+%%DATADIR%%/WS/README.txt
+%%DATADIR%%/WS/WS-Addressing.xsd
+%%DATADIR%%/WS/WS-Addressing03.xsd
+%%DATADIR%%/WS/WS-Addressing04.xsd
+%%DATADIR%%/WS/WS-Addressing05.xsd
+%%DATADIR%%/WS/WS-Discovery.wsdl
+%%DATADIR%%/WS/WS-Enumeration.wsdl
+%%DATADIR%%/WS/WS-Policy.xsd
+%%DATADIR%%/WS/WS-Policy12.xsd
+%%DATADIR%%/WS/WS-ReliableMessaging.wsdl
+%%DATADIR%%/WS/WS-ReliableMessaging.xsd
+%%DATADIR%%/WS/WS-Routing.xsd
+%%DATADIR%%/WS/WS-SecureConversation.xsd
+%%DATADIR%%/WS/WS-SecurityPolicy.xsd
+%%DATADIR%%/WS/WS-Trust.wsdl
+%%DATADIR%%/WS/WS-Trust.xsd
+%%DATADIR%%/WS/WS-typemap.dat
+%%DATADIR%%/WS/discovery.xsd
+%%DATADIR%%/WS/ds.xsd
+%%DATADIR%%/WS/enumeration.xsd
+%%DATADIR%%/WS/reference-1.1.xsd
+%%DATADIR%%/WS/typemap.dat
+%%DATADIR%%/WS/ws-bpel_abstract_common_base.xsd
+%%DATADIR%%/WS/ws-bpel_executable.xsd
+%%DATADIR%%/WS/ws-bpel_plnktype.xsd
+%%DATADIR%%/WS/ws-bpel_serviceref.xsd
+%%DATADIR%%/WS/ws-bpel_varprop.xsd
+%%DATADIR%%/WS/ws-reliability-1.1.xsd
+%%DATADIR%%/WS/wsse.xsd
+%%DATADIR%%/WS/wsu.xsd
+%%DATADIR%%/WS/xenc.xsd
+%%DATADIR%%/custom/README.txt
+%%DATADIR%%/custom/duration.c
+%%DATADIR%%/custom/duration.h
+%%DATADIR%%/custom/long_double.c
+%%DATADIR%%/custom/long_double.h
+%%DATADIR%%/custom/struct_timeval.c
+%%DATADIR%%/custom/struct_timeval.h
+%%DATADIR%%/custom/struct_tm.c
+%%DATADIR%%/custom/struct_tm.h
+%%DATADIR%%/custom/wsrmdemo-duration.o
+%%DATADIR%%/custom/wsrmdemo_ssl-duration.o
+%%DATADIR%%/custom/wsrmdemo_udp-duration.o
+%%DATADIR%%/extras/README.txt
+%%DATADIR%%/extras/ckdb.c
+%%DATADIR%%/extras/ckdb.h
+%%DATADIR%%/extras/ckdbtest.c
+%%DATADIR%%/extras/ckdbtest.h
+%%DATADIR%%/extras/fault.cpp
+%%DATADIR%%/extras/logging.cpp
+%%DATADIR%%/extras/soapdefs.h
+%%DATADIR%%/import/README.txt
+%%DATADIR%%/import/WS-Header.h
+%%DATADIR%%/import/WS-example.c
+%%DATADIR%%/import/WS-example.h
+%%DATADIR%%/import/c14n.h
+%%DATADIR%%/import/dom.h
+%%DATADIR%%/import/ds.h
+%%DATADIR%%/import/ds2.h
+%%DATADIR%%/import/plnk.h
+%%DATADIR%%/import/ref.h
+%%DATADIR%%/import/ser.h
+%%DATADIR%%/import/soap12.h
+%%DATADIR%%/import/stdstring.h
+%%DATADIR%%/import/stl.h
+%%DATADIR%%/import/stldeque.h
+%%DATADIR%%/import/stllist.h
+%%DATADIR%%/import/stlset.h
+%%DATADIR%%/import/stlvector.h
+%%DATADIR%%/import/vprop.h
+%%DATADIR%%/import/wsa.h
+%%DATADIR%%/import/wsa3.h
+%%DATADIR%%/import/wsa4.h
+%%DATADIR%%/import/wsa5.h
+%%DATADIR%%/import/wsc.h
+%%DATADIR%%/import/wsc2.h
+%%DATADIR%%/import/wsdd.h
+%%DATADIR%%/import/wsdd10.h
+%%DATADIR%%/import/wsdx.h
+%%DATADIR%%/import/wsp.h
+%%DATADIR%%/import/wsrm.h
+%%DATADIR%%/import/wsrm4.h
+%%DATADIR%%/import/wsrm5.h
+%%DATADIR%%/import/wsrp.h
+%%DATADIR%%/import/wsrx.h
+%%DATADIR%%/import/wsrx5.h
+%%DATADIR%%/import/wsse.h
+%%DATADIR%%/import/wsse11.h
+%%DATADIR%%/import/wsse2.h
+%%DATADIR%%/import/wst.h
+%%DATADIR%%/import/wstx.h
+%%DATADIR%%/import/wsu.h
+%%DATADIR%%/import/xenc.h
+%%DATADIR%%/import/xlink.h
+%%DATADIR%%/import/xmime.h
+%%DATADIR%%/import/xmime4.h
+%%DATADIR%%/import/xmime5.h
+%%DATADIR%%/import/xml.h
+%%DATADIR%%/import/xmlmime.h
+%%DATADIR%%/import/xmlmime5.h
+%%DATADIR%%/import/xop.h
+%%DATADIR%%/import/xsd.h
+%%DATADIR%%/plugin/README.txt
+%%DATADIR%%/plugin/cacerts.c
+%%DATADIR%%/plugin/cacerts.h
+%%DATADIR%%/plugin/calcrest.h
+%%DATADIR%%/plugin/httpda.c
+%%DATADIR%%/plugin/httpda.h
+%%DATADIR%%/plugin/httpdatest.c
+%%DATADIR%%/plugin/httpdatest.h
+%%DATADIR%%/plugin/httpform.c
+%%DATADIR%%/plugin/httpform.h
+%%DATADIR%%/plugin/httpget.c
+%%DATADIR%%/plugin/httpget.h
+%%DATADIR%%/plugin/httpget.o
+%%DATADIR%%/plugin/httpgettest.c
+%%DATADIR%%/plugin/httpgettest.h
+%%DATADIR%%/plugin/httpmd5.c
+%%DATADIR%%/plugin/httpmd5.h
+%%DATADIR%%/plugin/httpmd5test.c
+%%DATADIR%%/plugin/httpmd5test.h
+%%DATADIR%%/plugin/httppost.c
+%%DATADIR%%/plugin/httppost.h
+%%DATADIR%%/plugin/httppost.o
+%%DATADIR%%/plugin/httpposttest.c
+%%DATADIR%%/plugin/httpposttest.h
+%%DATADIR%%/plugin/logging.c
+%%DATADIR%%/plugin/logging.h
+%%DATADIR%%/plugin/md5evp.c
+%%DATADIR%%/plugin/md5evp.h
+%%DATADIR%%/plugin/mecevp.c
+%%DATADIR%%/plugin/mecevp.h
+%%DATADIR%%/plugin/mq.c
+%%DATADIR%%/plugin/mq.h
+%%DATADIR%%/plugin/plugin.c
+%%DATADIR%%/plugin/plugin.h
+%%DATADIR%%/plugin/smdevp.c
+%%DATADIR%%/plugin/smdevp.h
+%%DATADIR%%/plugin/sslserver-threads.o
+%%DATADIR%%/plugin/threads.c
+%%DATADIR%%/plugin/threads.h
+%%DATADIR%%/plugin/wsaapi.c
+%%DATADIR%%/plugin/wsaapi.h
+%%DATADIR%%/plugin/wsademo-wsaapi.o
+%%DATADIR%%/plugin/wsddapi.c
+%%DATADIR%%/plugin/wsddapi.h
+%%DATADIR%%/plugin/wsrmapi.c
+%%DATADIR%%/plugin/wsrmapi.h
+%%DATADIR%%/plugin/wsrmdemo-threads.o
+%%DATADIR%%/plugin/wsrmdemo-wsaapi.o
+%%DATADIR%%/plugin/wsrmdemo-wsrmapi.o
+%%DATADIR%%/plugin/wsrmdemo_ssl-threads.o
+%%DATADIR%%/plugin/wsrmdemo_ssl-wsaapi.o
+%%DATADIR%%/plugin/wsrmdemo_ssl-wsrmapi.o
+%%DATADIR%%/plugin/wsrmdemo_udp-threads.o
+%%DATADIR%%/plugin/wsrmdemo_udp-wsaapi.o
+%%DATADIR%%/plugin/wsrmdemo_udp-wsrmapi.o
+%%DATADIR%%/plugin/wsse2api.c
+%%DATADIR%%/plugin/wsse2api.h
+%%DATADIR%%/plugin/wsseapi.c
+%%DATADIR%%/plugin/wsseapi.cpp
+%%DATADIR%%/plugin/wsseapi.h
+%%DATADIR%%/plugin/wssedemo-mecevp.o
+%%DATADIR%%/plugin/wssedemo-smdevp.o
+%%DATADIR%%/plugin/wssedemo-wsseapi.o